_G.HeadInd = _G.HeadInd or {}
HeadInd._path = ModPath
HeadInd._data_path = SavePath .. "headind_data.txt"
HeadInd._data = {} 

function HeadInd:Save()
	local file = io.open( self._data_path, "w+" )
	if file then
		file:write( json.encode( self._data ) )
		file:close()
	end
end

function HeadInd:Load()
	local file = io.open( self._data_path, "r" )
	if file then
		self._data = json.decode( file:read("*all") )
		file:close()
	end
end

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_HeadInd", function( loc )
	loc:load_localization_file( HeadInd._path .. "en.txt")
end)

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_HeadInd", function( menu_manager )
	MenuCallbackHandler.callback_size_slider = function(self, item)
		HeadInd._data.size = item:value()
		HeadInd:Save()
	end
	MenuCallbackHandler.callback_red_slider = function(self, item)
		HeadInd._data.red = item:value()
		HeadInd:Save()
	end
	MenuCallbackHandler.callback_green_slider = function(self, item)
		HeadInd._data.green = item:value()
		HeadInd:Save()
	end
	MenuCallbackHandler.callback_blue_slider = function(self, item)
		HeadInd._data.blue = item:value()
		HeadInd:Save()
	end
	HeadInd:Load()
	MenuHelper:LoadFromJsonFile( HeadInd._path .. "menu.txt", HeadInd, HeadInd._data )
end )

HeadInd:Load()

if RequiredScript == "lib/managers/hud/hudhitconfirm" then
	local old_init = HUDHitConfirm.init
	function HUDHitConfirm:init(...)
		old_init(self, ...)
		local size = HeadInd._data.size or 24
		local red = (HeadInd._data.red or 80)/100
		local green = (HeadInd._data.green or 20)/100
		local blue = (HeadInd._data.blue or 20)/100
		local new_color = Color(red, green, blue)
		if self._hud_panel:child("headshot_confirm") then
			self._hud_panel:remove(self._hud_panel:child("headshot_confirm"))
		end
		self._headshot_confirm = self._hud_panel:bitmap({
			valign = "center",
			halign = "center",
			visible = false,
			name = "headshot_confirm",
			texture = "guis/textures/pd2/hud_progress_active",
			color = new_color,
			layer = 1,
			h = size,
			w = size,
			blend_mode = "normal"
		})
		self._headshot_confirm:set_center(self._hud_panel:w() / 2, self._hud_panel:h() / 2)
	end
	function HUDHitConfirm:on_headshot_confirmed()
		self._headshot_confirm:stop()
		self._headshot_confirm:animate(callback(self, self, "_animate_show"), callback(self, self, "show_done"), 0.25)
	end
end

if RequiredScript == "lib/managers/playermanager" then
	local old_ohd = PlayerManager.on_headshot_dealt
	function PlayerManager:on_headshot_dealt(...)
		managers.hud:on_headshot_confirmed()
		return old_ohd(self, ...)
	end
end